import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

// Autor: %AUTHOR%
// Datum: %DATE%

public class Postfixrechner_GUI extends JFrame {
  // Anfang Attribute
  private JLabel labOperand = new JLabel();
  private JLabel labOperator = new JLabel();
  private JTextField tfOperand = new JTextField();
  private JButton btPlus = new JButton();
  private JButton btMinus = new JButton();
  private JButton btMal = new JButton();
  private JButton btDurch = new JButton();
  private JButton btEnter = new JButton();
  private JLabel labPostfixterm = new JLabel();
  private JButton btReset = new JButton();
  private JLabel labProtokoll = new JLabel();
  private JLabel labTop = new JLabel();
  // Ende Attribute
  private Postfixrechner rechner = new Postfixrechner();
  
  public Postfixrechner_GUI(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 507; 
    int frameHeight = 228;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    labOperand.setBounds(16, 16, 110, 20);
    labOperand.setText("Zahleingabe");
    cp.add(labOperand);
    labOperator.setBounds(288, 16, 110, 20);
    labOperator.setText("Operatoreingabe");
    cp.add(labOperator);
    tfOperand.setBounds(16, 48, 150, 20);
    cp.add(tfOperand);
    btPlus.setBounds(288, 48, 27, 25);
    btPlus.setText("+");
    btPlus.setMargin(new Insets(2, 2, 2, 2));
    btPlus.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btPlus_ActionPerformed(evt);
      }
    });
    btPlus.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(btPlus);
    btMinus.setBounds(328, 48, 27, 25);
    btMinus.setText("-");
    btMinus.setMargin(new Insets(2, 2, 2, 2));
    btMinus.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btMinus_ActionPerformed(evt);
      }
    });
    btMinus.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(btMinus);
    btMal.setBounds(368, 48, 27, 25);
    btMal.setText("*");
    btMal.setMargin(new Insets(2, 2, 2, 2));
    btMal.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btMal_ActionPerformed(evt);
      }
    });
    btMal.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(btMal);
    btDurch.setBounds(408, 48, 27, 25);
    btDurch.setText("/");
    btDurch.setMargin(new Insets(2, 2, 2, 2));
    btDurch.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btDurch_ActionPerformed(evt);
      }
    });
    btDurch.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(btDurch);
    btEnter.setBounds(176, 48, 75, 25);
    btEnter.setText("ENTER");
    btEnter.setMargin(new Insets(2, 2, 2, 2));
    btEnter.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btEnter_ActionPerformed(evt);
      }
    });
    cp.add(btEnter);
    labPostfixterm.setBounds(8, 120, 478, 20);
    labPostfixterm.setText("");
    labPostfixterm.setFont(new Font("Dialog", Font.BOLD, 14));
    cp.add(labPostfixterm);
    btReset.setBounds(264, 152, 219, 25);
    btReset.setText("RESET");
    btReset.setMargin(new Insets(2, 2, 2, 2));
    btReset.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btReset_ActionPerformed(evt);
      }
    });
    btReset.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(btReset);
    labProtokoll.setBounds(8, 96, 239, 20);
    labProtokoll.setText("Eingabeprotokoll");
    cp.add(labProtokoll);
    labTop.setBounds(8, 152, 246, 20);
    labTop.setText("Top: ");
    cp.add(labTop);
    // Ende Komponenten
    
    setVisible(true);
  } // end of public Postfixrechner_GUI
  
  // Anfang Methoden
  
  public static void main(String[] args) {
    new Postfixrechner_GUI("Postfixrechner_GUI");
  } // end of main
  
  public void btPlus_ActionPerformed(ActionEvent evt) {
    labPostfixterm.setText(labPostfixterm.getText()+" +");
    rechner.bearbeiteOperator('+');
    labTop.setText("Top: "+ rechner.gibTopwert());
  } // end of btPlus_ActionPerformed
  
  public void btMinus_ActionPerformed(ActionEvent evt) {
    rechner.bearbeiteOperator('-');
    labPostfixterm.setText(labPostfixterm.getText()+" -");
    labTop.setText("Top: "+ rechner.gibTopwert());
  } // end of btMinus_ActionPerformed
  
  public void btMal_ActionPerformed(ActionEvent evt) {
    rechner.bearbeiteOperator('*');
    labPostfixterm.setText(labPostfixterm.getText()+" *");
    labTop.setText("Top: "+ rechner.gibTopwert());
  } // end of btMal_ActionPerformed
  
  public void btDurch_ActionPerformed(ActionEvent evt) {
    rechner.bearbeiteOperator('/');
    labPostfixterm.setText(labPostfixterm.getText()+" /");
    labTop.setText("Top: "+ rechner.gibTopwert());
  } // end of btDurch_ActionPerformed
  
  public void btEnter_ActionPerformed(ActionEvent evt) {
    String zahlstr = tfOperand.getText();
    tfOperand.setText("");
    int zahl = Integer.valueOf(zahlstr);
    rechner.bearbeiteOperand(zahl);
    labPostfixterm.setText(labPostfixterm.getText()+" "+zahlstr);
    labTop.setText("Top: "+ rechner.gibTopwert());
  } // end of btEnter_ActionPerformed
  
  public void btReset_ActionPerformed(ActionEvent evt) {
    tfOperand.setText("");
    labPostfixterm.setText("");
    labTop.setText("Top: ");
    rechner = new Postfixrechner();
  } // end of btReset_ActionPerformed
  
  // Ende Methoden
} // end of class Postfixrechner_GUI
