import java.util.*;
public class Praxis {
  private int oeffnungszeit;
  private int prognosezahl;
  private Random zufall;
  private Arzt derArzt;
  private Queue<Patient> patienten;
  private int leerlaufzeit;
  private int patientenzahl;

  public Praxis() {
    oeffnungszeit = 180;
    prognosezahl = 20;
    zufall = new Random();
    derArzt = new Arzt();
    patienten = new Queue<Patient>();
    patientenzahl = 0;
    leerlaufzeit = 0;
  }

  private void zeittakt() {
    if (zufall.nextInt(oeffnungszeit) < prognosezahl) {
      Patient neu = new Patient(5 + zufall.nextInt(10));
      patienten.enqueue(neu);
      patientenzahl = patientenzahl + 1;
    }
    if (derArzt.istFrei()) {
      if (!patienten.isEmpty()) {
        Patient p = patienten.front();
        patienten.dequeue();
        derArzt.neuerPatient(p.gibZeitbedarf());
      } else {
        leerlaufzeit = leerlaufzeit + 1;
      }
    } 
    derArzt.behandeltPatient();     
  }

  public void simulierePraxis() {
    for (int i = 0; i <= oeffnungszeit; i++) {
      zeittakt();
    }
  }

  public String gibAuswertung() {
    int patientenzahlEnde = 0;
    int behandlungszeit = 0;
    while (!patienten.isEmpty()) {
      Patient p = patienten.front();
      patienten.dequeue();
      patientenzahlEnde = patientenzahlEnde + 1;
      behandlungszeit = behandlungszeit + p.gibZeitbedarf();
    }
    String ausgabe = "Auswertung der Praxissimulation" + "\n";
    ausgabe = ausgabe + "Sprechstundenzeit in Minuten: " + oeffnungszeit + "\n";
    ausgabe = ausgabe + "Erwartete Patientenzahl: " + prognosezahl+ "\n";
    ausgabe = ausgabe + "Tatsaechliche Patientenzahl: " + patientenzahl+ "\n";
    ausgabe = ausgabe + "Leerlaufzeit beim Arzt (in Minuten): " + leerlaufzeit+ "\n";

    ausgabe = ausgabe + "\n" + "Situation am Ende der Sprechstundenzeit" + "\n";
    ausgabe = ausgabe + "Patienten im Wartezimmer: " + patientenzahlEnde + "\n";
    ausgabe = ausgabe + "Zeitbedarf für die Patienten im Wartezimmer: " + behandlungszeit + "\n";
    return ausgabe;
  }

  public void setzeOeffnungszeit(int pZeit) {
    oeffnungszeit = pZeit;
  }

  public void setzePrognosezahl(int pPrognosezahl) {
    prognosezahl = pPrognosezahl;
  }

}
